#ifndef _BASEXMLFILE_H
#define _BASEXMLFILE_H

#include <string>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>


class BaseXMLFile
{
public:
	BaseXMLFile(const std::string& filename,const std::string& verify_ns = "",const std::string& verify_root = "");
	~BaseXMLFile();

	xmlDocPtr GetDocument() { return m_doc; }
	xmlNodePtr GetRootElement();
	std::string GetProperty(const std::string& );
	xmlNodePtr GetChildrenNode();
	xmlNodePtr GetNextNode();
	const std::string& GetNodeName();
	void SetCurrent(xmlNodePtr p) { m_current = p; }
	xmlNsPtr GetNodeNs();
	const std::string& GetNodeNsPrefix();
	const std::string& GetNodeNsHref();

	xmlNodePtr GetFirstElement(const std::string& );
	xmlNodePtr GetFirstElement(xmlNodePtr,const std::string& );
	xmlNodePtr GetNextElement(xmlNodePtr,const std::string& );

	bool IsOk() { return m_ok; }

private:
	xmlDocPtr m_doc;
	xmlNodePtr m_current;
	std::string m_current_name;
	std::string m_ns_prefix;
	std::string m_ns_href;
	bool m_ok;
};




#endif // _BASEXMLFILE_H
