//#include <stdio.h>

#include "Robot.h"
#include "RobotObject.h"




RobotObject::RobotObject(Robot& r) : m_robot(r)
,m_max_life(100)
,m_life(100)
,m_repair_rate(10) // % of max power/sec
{
}


RobotObject::~RobotObject()
{
}


void RobotObject::Tick(long usec)
{
	if (m_life < m_max_life)
	{
		double repair_units_per_sec = (m_repair_rate * GetRobot().GetMaxPowerLevel()) / 100;
		double power_units = (repair_units_per_sec * usec) / 1000000;
		if (GetRobot().UsePower(power_units))
		{
			m_life += power_units / 100;
			if (m_life > m_max_life)
				m_life = m_max_life;
		}
	}
}


